/*************************************************************************
***** Programm: BIER.EXE
***** Unterprogramm: ABLAUF.C
***** Steuert den zeitlichen Ablauf der einzelnen Brauphasen
*****
***** Hauptprogramm: DRU_TEM.C
***** Unterprogramme: TABELL2.C, KREIS.C, ABLAUF.C
*****
***** Autoren: Michael Fey
***** Erstellt am: 27.12.1996
***** Update: 5.1.1997
*************************************************************************/
#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>

#define Par_Sst 0x378

#define AN 1
#define AUS 0

#define ESC 0x11b
#define RETURN 0x1c0d

#define HEIZUNG  16
#define WASSER 2
#define MOTOR_L 4
#define MOTOR_R 8
#define PUMPEN 1
#define SPUELEN 32
#define CHECKEN 64

#define LAENGE 111
#define SAETZE 50

#define AUFHEIZEN 0
#define EINMAISCHEN 1
#define EIWEISS 2
#define MALTOSE 3
#define ZUCKER 4
#define LAEUTERN 5
#define KOCHEN 6
#define ABFUELLEN 7
#define REINIGEN 8

#define F1 0x3b00
#define F2 0x3c00
#define F3 0x3d00
#define F4 0x3e00
#define F5 0x3f00
#define F6 0x4000
#define F7 0x4100
#define F8 0x4200
#define F9 0x4300
#define F10 0x4400

extern struct {
	  char name[20+1];
	  int liter;
	  int malz;
	  int hopfen;
	  int eiw_temperatur;
	  int eiw_gesamtzeit;
	  int eiw_motorzeit;
	  int eiw_motorintervall;
	  int malt_temperatur;
	  int malt_gesamtzeit;
	  int malt_motorzeit;
	  int malt_motorintervall;
	  int zucker_temperatur;
	  int zucker_gesamtzeit;
	  int zucker_motorzeit;
	  int zucker_motorintervall;
	  int koch_zeit;
	  int koch_temperatur;
     int koch_unterbrechung;
	}
	zeile[SAETZE];
extern int Nummer;
int AnfangsDruck;

void Zeitsteuerung();
void Meldung ( char MeldeText[74] );
void WasserZulauf(int SollLiter, int Spuelen);
void WasserAblauf();
int AufHeizen( int SollTemp );
int TempPruefung();
int BreakTest();
int DruckFormel();
void AblaufBildschirm();

/***************************************************************************
***** Funktion, um Programmablauf zeitlich zu steuern
***************************************************************************/

void ZeitSteuerung()
{
	time_t Datum,
			 BegRast, tBegMotor, tEndMotor, tDauMotor;
	int RastDauer, MotorDauer, MotorIntervall;

	int vEnde = 0;
	int Ende;
	int PumpEnde = 0;
	int Taste;
	int MotorFlag = 0, KochFlag = 0;
	int IstLiter;
	int Rast = 0;
	int SollTemp;
	int tempera, Druck, TempFormel;
	long double DruckFormel;

AblaufBildschirm();
Meldung("Starten des Wasserzulaufs mit RETURN, Abbruch mit ESC");
for (Ende = 1; Ende != 0;)
	{
		Taste = Unterbrechung();
		if (Taste == ESC)
			{
				Warnton();
				vEnde = 1;
				Ende = 0;
			}
		if (Taste == RETURN) Ende = 0;
		delay(500);
	}

if (vEnde == 0) WasserZulauf(zeile[Nummer].liter, AUS);

	for (; vEnde == 0 && Rast < 8;)
		{
			Rast ++;
			switch (Rast)
				{

					case EINMAISCHEN:  gotoxy(5,5);
										cprintf("Brauphase: Einmaischen                              ");
										SollTemp = 40;
										MotorDauer = zeile[Nummer].eiw_motorzeit;
										MotorIntervall = zeile[Nummer].eiw_motorintervall;
										RastDauer = 10;
										break;

					case EIWEISS:  gotoxy(5,5);
										cprintf("Brauphase: Eiweirast                              ");
										SollTemp = zeile[Nummer].eiw_temperatur;
										MotorDauer = zeile[Nummer].eiw_motorzeit;
										MotorIntervall = zeile[Nummer].eiw_motorintervall;
										RastDauer = zeile[Nummer].eiw_gesamtzeit;
										break;

					case MALTOSE:  gotoxy(5,5);
										cprintf("Brauphase: Maltoserast                             ");
										SollTemp = zeile[Nummer].malt_temperatur;
										MotorDauer = zeile[Nummer].malt_motorzeit;
										MotorIntervall = zeile[Nummer].malt_motorintervall;
										RastDauer = zeile[Nummer].malt_gesamtzeit;
										break;

					case ZUCKER:   gotoxy(5,5);
										cprintf("Brauphase: Verzuckerungsphase                      ");
										SollTemp=zeile[Nummer].zucker_temperatur;
										MotorDauer = zeile[Nummer].zucker_motorzeit;
										MotorIntervall = zeile[Nummer].zucker_motorintervall;
										RastDauer = zeile[Nummer].zucker_gesamtzeit;
										break;

					case LAEUTERN:   gotoxy(5,5);
										cprintf("Brauphase: Lutern                      ");
										SollTemp=77;
										MotorDauer = zeile[Nummer].zucker_motorzeit;
										MotorIntervall = zeile[Nummer].zucker_motorintervall;
										RastDauer = 15;
										break;

					case KOCHEN:   gotoxy(5,5);
										cprintf("Brauphase: In Luterbottich pumpen                 ");
										Meldung("Bitte Ablaufschlauch in  Luterbottich hngen. Weiter mit F10!");
										Warnton();
										for(;PumpEnde < 3;)
											{
												Taste = Unterbrechung();
												if (Taste == F10)
													{
														PumpEnde = 1;
														schalten (PUMPEN,AN);
														Meldung("Unterbrechen des Abpumpens mit ESC!");
														Warnton();
													 }
												if (Taste == ESC && PumpEnde == 2)
													{
														schalten (PUMPEN,AUS);
														PumpEnde = 3;
													 }
												if (Taste == ESC && PumpEnde == 1)
													{
														PumpEnde = 2;
														schalten (PUMPEN,AUS);
														Meldung("Weiter Pumpen mit F10, Abbrechen mit ESC!");
													}
											 }
										Warnton();
										Meldung("Lutern ist beendet. Bitte Sud einfllen!");
										delay(5000);
										PumpEnde = 0;
										for(; PumpEnde ==0;)
											{
												Meldung("Weiter mit dem Kochprogramm mit F10!");
												Taste = Unterbrechung();
												if (Taste == F10) PumpEnde = 1;
											}
										gotoxy(5,5);
										cprintf("Brauphase: Kochen                                  ");
										SollTemp=zeile[Nummer].koch_temperatur;
										RastDauer = zeile[Nummer].koch_zeit;
										break;

					case ABFUELLEN: gotoxy(5,5);
										SollTemp=0;
										cprintf("Brauphase: Abfllen des Bieres                     ");
										gotoxy(5,12);
										cprintf("Soll-Temperatur: %d Grad  ", SollTemp);
										Meldung("Bitte den Ablaufschlauch in das Grgef halten. Weiter mit bel. Taste!");
										getch();
										WasserAblauf();
										break;

					case REINIGEN:  gotoxy(5,5);
										cprintf("Brauphase: Reinigen der Maschine                 ");
										SollTemp = 0;
										Meldung("Bitte den Ablaufschlauch in einen Abflu hngen. Weiter mit bel. Taste!");
										getch();
										WasserZulauf(30,1);
										WasserAblauf();
										break;

				}
				gotoxy(5,12);
				cprintf("Soll-Temperatur: %d Grad  ", SollTemp);
				if (Rast < ABFUELLEN ) vEnde = AufHeizen(SollTemp);
				tBegMotor = (time(NULL) + MotorIntervall * 60);
				tEndMotor = (time(NULL) + MotorDauer);
				BegRast = time(NULL);

				for (;time(NULL) < (BegRast + RastDauer * 60)
						&& vEnde == 0 && Rast < ABFUELLEN;)
					{
						if (tBegMotor <= time(NULL) && MotorFlag == 0)
							{
								tEndMotor = (tBegMotor + MotorDauer);
								MotorFlag = 1;
								gotoxy(25,14);
								cprintf("EIN");
								if (Motor( AN )==1) break;
							}
							if (tEndMotor <= time(NULL) && MotorFlag == 1)
							{
								tBegMotor = (tEndMotor + MotorIntervall * 60);
								MotorFlag = 0;
								gotoxy(25,14);
								cprintf("AUS");
								if (Motor( AUS )==1) break;
							}
						if(TempPruefung() < SollTemp)
							{
								gotoxy(25,13);
								cprintf("EIN");
								schalten(HEIZUNG,AN);
							}
						else
							{
								gotoxy(25,13);
								cprintf("AUS");
								schalten(HEIZUNG,AUS);
							}
						time(&Datum);
						gotoxy(25,8);
						cprintf("%s", ctime(&Datum));
						if (Rast == KOCHEN && KochFlag == 0 && time(NULL) >= (BegRast + zeile[Nummer].koch_unterbrechung * 60))
							{
								KochFlag = 1;
								schalten(HEIZUNG, AUS);
								Meldung("Kochunterbrechung! Fortsetzen mit beliebiger Taste");
								Warnton();
								getch();
							}
						delay(1000);
						vEnde = BreakTest();
					}
			gotoxy(25,13);
			cprintf("AUS");
			schalten(HEIZUNG,AUS);

			if (MotorFlag == 1)
				{
					tBegMotor = (tEndMotor + MotorIntervall * 60);
					MotorFlag = 0;
					gotoxy(25,14);
					cprintf("AUS");
					if (Motor( AUS )==1) break;
				}

			if (vEnde != 0)
				switch (vEnde)
				{
					case 2: vEnde = 0; break;
					case 3: Meldung("Die Relais wurden abgeschaltet und das Programm abgebrochen!");
							  outportb(Par_Sst, 0);
							  delay(2000);
							  return;
				}
		}

				outportb(Par_Sst, 0);
				Meldung("Die Relais wurden abgeschaltet! Ende des Programms!");
				delay(5000);

	return;

}
/***************************************************************************
***** Gibt Meldungstext auf der Fuzeile aus
***************************************************************************/

void Meldung ( char MeldeText[80+1])

{
	gotoxy (5,25);
	cprintf  ("                                                                           ");
	gotoxy (5,25);
	cprintf( MeldeText );
}

/***************************************************************************
***** Rechnet die Frequenz in Literzahl um und zeigt sie an
***************************************************************************/
int DruckFormel()
{
	int Druck, IstLiter;
	double Druckergebnis, Drucksumme;
	Druck = druckmess();
	Drucksumme = (Druck - AnfangsDruck);
	if (Drucksumme < 140) Druckergebnis = (Drucksumme / 28.00);
	else Druckergebnis = ((Drucksumme / 20.00) + 5);
	gotoxy(60,10);
	cprintf("%.1f      ", Druckergebnis);
	IstLiter = Druckergebnis;
	return (IstLiter);
}

/***************************************************************************
***** Steuert den Wasserzulauf zu Beginn des Brauens und beim Spuelen
***************************************************************************/
void WasserZulauf(int SollLiter, int Spuelen)

{
	int IstLiter,vEnde = 0;
	Meldung("Druck (Wasser) berprfen und ggf. ein- oder ausschalten");
	AnfangsDruck = druckmess();
	IstLiter = DruckFormel();

	if (IstLiter <  SollLiter && Unterbrechung() != ESC)
		{
			if (Spuelen == AUS)
				{
					schalten(SPUELEN, AN);
					gotoxy(25,11);
				}
			else
				{
					schalten(SPUELEN, AN);
					gotoxy(25,16);
				}
			cprintf("EIN");
		}
	for (;IstLiter <  SollLiter && vEnde == 0;)
		{
			vEnde = BreakTest();
			IstLiter = DruckFormel();
		}

	Meldung("Soll-Wassermenge erreicht");
	if (Spuelen == AUS)
		{
			schalten(SPUELEN, AUS);
			gotoxy(25,11);
		}
	else
		{
			schalten(WASSER, AUS);
			gotoxy(25,16);
		}
	cprintf("AUS");
	Hinweiston();
	delay(2000);
}

/***************************************************************************
***** Steuert das Abpumpen zum Ende des Brauens
***************************************************************************/
void WasserAblauf()

{
	int IstLiter, vEnde = 0;
	Meldung("Wasser berprfen und abpumpen");
	IstLiter = DruckFormel();

	if (IstLiter >=  0  && Unterbrechung() != ESC)
		{
			schalten(PUMPEN, AN);
			gotoxy(25,16);
			cprintf("EIN");
		}
	for (;IstLiter >  0  && vEnde == 0;)
		{
				IstLiter = DruckFormel();
				vEnde = BreakTest();
		}
	Meldung("Wasser ist abgepumpt");
	schalten(PUMPEN, AUS);
	gotoxy(25,16);
	cprintf("AUS");
	Hinweiston();
	delay(2000);
}

/***************************************************************************
***** berprft die Temperatur und rechnet sie um
***************************************************************************/
int TempPruefung()
{
	int temp;
	double TempFormel;
/*	double tempera, Herz;
	Herz = tempmess() - 1573;
	tempera = 10.00;
	gotoxy(60,12);
	TempFormel = (Herz / tempera) ;
	temp = TempFormel;
	cprintf("%.1f      ", TempFormel);
*/
	temp = tempmess();
	TempFormel = temp / 10.00;
	gotoxy(60,12);
	cprintf("%.1f   ", TempFormel);
	return (temp/10);
}
/***************************************************************************
***** Steuert das Aufheizen zu Beginn der einzelnen Brauphasen
***************************************************************************/
int AufHeizen( int SollTemp )
{

	int vEnde = 0;

	Meldung("Wasser wird aufgeheizt");
	for(;TempPruefung() < SollTemp && vEnde == 0;)
		{
			gotoxy(25,13);
			cprintf("EIN");
			schalten(HEIZUNG,AN);
			vEnde = BreakTest();
		}

	if (vEnde == 0)
		{
			gotoxy(25,13);
			cprintf("AUS");
			Meldung("Soll-Temperatur erreicht");
			schalten(HEIZUNG,AUS);
			Hinweiston();
			delay(2000);
		}
	return( vEnde);
}

/***************************************************************************
***** Gestaltet den Standardbildschirm fr den Brauablauf
***************************************************************************/

void AblaufBildschirm()
{
	time_t Datum;
	clrscr();
	gotoxy(5,2);
	cprintf("Zeitsteuerung fr das Brauen von %s", zeile[Nummer].name);
	gotoxy(5,3);
	cprintf("Sie brauchen %i kg Malz und %i g Hopfen", zeile[Nummer].malz, zeile[Nummer].hopfen);
	gotoxy(5,5);
	cprintf("Brauvorgang: Vorbereitung des Brauwassers");
	gotoxy(5,7);
	cprintf("Anfangszeit:");
	time(&Datum);
	gotoxy(25,7);
	cprintf("%s", ctime(&Datum));
	gotoxy(5,8);
	cprintf("Aktuelle Zeit:");
	time(&Datum);
	gotoxy(25,8);
	cprintf("%s", ctime(&Datum));
	gotoxy(5,10);
	cprintf("Soll-Wassermenge: %d", zeile[Nummer].liter);
	gotoxy(39,10);
	cprintf("Ist-Wassermenge:");
	gotoxy(5,11);
	cprintf("Wasserzulauf:");
	gotoxy(25,11);
	cprintf("AUS");
	gotoxy(39,12);
	cprintf("Ist-Temperatur:");
	gotoxy(5,13);
	cprintf("Heizung:");
	gotoxy(25,13);
	cprintf("AUS");
	gotoxy(5,14);
	cprintf("Motor:");
	gotoxy(25,14);
	cprintf("AUS");
	gotoxy(5,15);
	cprintf("Splen:");
	gotoxy(25,15);
	cprintf("AUS");
	gotoxy(5,16);
	cprintf("Abpumpen:");
	gotoxy(25,16);
	cprintf("AUS");

}
/***************************************************************************
***** BreakTest ermglicht, das Programm zu unterbrechen
***************************************************************************/

int BreakTest()
{

int vEnde = 0;
int RelaisAlt = 0, RelaisNeu;


	if (Unterbrechung() == ESC)
		{
			RelaisAlt = inportb(Par_Sst);
			outportb(Par_Sst,0);
			vEnde = EndeFal();
			switch (vEnde)
				{
					case 1: 	vEnde = 0;
								Meldung("Programm wird fortgesetzt!");
								outportb(Par_Sst,RelaisAlt);
								break;
					case 2:  Meldung("Der aktuelle Brauablauf wird bersprungen!");
								gotoxy(25,11);
								cprintf("AUS");
								gotoxy(25,13);
								cprintf("AUS");
								gotoxy(25,14);
								cprintf("AUS");
								gotoxy(25,15);
								cprintf("AUS");
								gotoxy(25,16);
								cprintf("AUS");
								schalten(CHECKEN,AN);
								break;
					case 3:	Meldung("Das Programm wird abgebrochen!");
								gotoxy(25,11);
								cprintf("AUS");
								gotoxy(25,13);
								cprintf("AUS");
								gotoxy(25,14);
								cprintf("AUS");
								gotoxy(25,15);
								cprintf("AUS");
								gotoxy(25,16);
								cprintf("AUS");
								break;
				}
			delay(2000);
		}
	return (vEnde);
}

/**********************************************/
